#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char** argv)
{
  if(argc == 1) {
    printf("Usage: %s <path_to_file.str>\n", argv[0]);
    return -1;
  }
  FILE *fp = fopen(argv[1], "rb");
  int len = strlen(argv[1]);
  char * out_name = (char*)calloc(len + 5, 1);
  memcpy(out_name, argv[1], len);
  strncat(out_name, ".raw", 4);
  
  FILE *fo = fopen(out_name, "wb");
  free(out_name);
  
  if(!fp || !fo) {
    puts("Error opening input/output files");
    return -1;
  }
  
  const int INTERLEAVE = 512;
  int ctr = 0;
  char buffer[512 * 2];
  const int width = 2;
  while(!feof(fp)) {
    if(ctr < INTERLEAVE) {
      fread(buffer + ((ctr / width) << 2), width, 1, fp);
      ctr += width;
    }
    else if(ctr < (INTERLEAVE * 2)) {
      fread(buffer + (((ctr - INTERLEAVE) / width) << 2) + width, width, 1, fp);
      ctr += width;
    }
    else {
      fwrite(buffer, (INTERLEAVE * 2), 1, fo);
      ctr = 0;
      memset(buffer, 0, (INTERLEAVE * 2));
    }
  }
  fclose(fp);
  fclose(fo);
  return 0;
}